|  | Home

# QScriptable Class Reference
[QtScript module]

The QScriptable class provides access to the Qt Script environment from Qt C++ member functions. More...

     #include <QScriptable>

This class is not part of the Qt GUI Framework Edition.

This class was introduced in qtscriptclassic 4.3.

- List of all members, including inherited members

## Public Functions

QScriptValue | argument ( int index ) const
int | argumentCount () const
QScriptContext * | context () const
QScriptEngine * | engine () const
QScriptValue | thisObject () const

## Detailed Description

The QScriptable class provides access to the Qt Script environment from Qt C++ member functions.

With QScriptEngine::newQObject(), you can expose the signals and slots and properties of any QObject (or subclass) to script code. QScriptable augments this functionality by giving your C++ members access to the Qt Script environment they are invoked in; conceptually, it is similar to QObject::sender().

By subclassing QScriptable, you get the following functions in your class: thisObject(), argumentCount(), argument(), context() and engine(). With these functions, you have full access to the Qt Script environment from the slots and property access functions of your class, when they are invoked from script code.

For example, you can throw a Qt Script exception from a slot; manipulate the `this' object associated with the function call; inspect the arguments stored in the QScriptContext to know the "real" arguments passed to the function from script code; and call script functions from your slot.

A typical use case of QScriptable is to implement prototype objects for custom C++ types. You define the scriptable interface of your custom type in a QScriptable subclass using properties and slots; then you wrap an instance of your class using QScriptEngine::newQObject(), and finally pass the result to QScriptEngine::setDefaultPrototype(). See the Default Prototypes Example to see how this can be done.

The following is what subclassing QScriptable typically looks like:

     class MyScriptableObject: public QObject,
           protected QScriptable
     {
         Q_OBJECT
     ...

     public slots:
         void doSomething();
         double doSomethingElse();
     }

The only difference from regular QObject subclassing is that you also inherit from QScriptable.

In the implementation of your slots, you can then use the functions inherited from QScriptable:

     void MyScriptableObject::doSomething()
     {
       context()->throwError("Threw an error from a slot");
     }

     double MyScriptableObject::doSomethingElse()
     {
       return qscriptvalue_cast<double>(thisObject());
     }

See also Default Prototypes Example and QScriptEngine::newFunction().

## Member Function Documentation

### QScriptValue QScriptable::argument ( int index ) const

Returns the function argument at the given index, or an invalid QScriptValue if the Qt function was not invoked from script code.

See also argumentCount().

### int QScriptable::argumentCount () const

Returns the number of arguments passed to the function in this invocation, or -1 if the Qt function was not invoked from script code.

See also argument().

### QScriptContext * QScriptable::context () const

Returns a pointer to the QScriptContext associated with the current Qt function call, or 0 if the Qt function was not invoked from script code.

### QScriptEngine * QScriptable::engine () const

Returns a pointer to the QScriptEngine associated with the current Qt function call, or 0 if the Qt function was not invoked from script code.

### QScriptValue QScriptable::thisObject () const

Returns the `this' object associated with the current Qt function call, or an invalid QScriptValue if the Qt function was not invoked from script code.